//------------------------------------------------------------------
// conveersion frp tradestation konkop code
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

extern double RaiK      = 1;
extern int    RaiSmooth = 10;

//
//
//
//
//

double raiu[];
double raid[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,raiu);
   SetIndexBuffer(1,raid);
      IndicatorShortName("Renko adaptive indicator ("+DoubleToStr(RaiK,2)+","+RaiSmooth+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][3];
#define _up    0
#define _dn    1
#define _brick 2

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
           

   //
   //
   //
   //
   //

   for(i=limit, r=Bars-i-1; i>=0; i--, r++)
   {
      if (r<2)
      {
         work[r][_up]    = High[i];
         work[r][_dn]    = Low[i];
         work[r][_brick] = RaiK*(High[i]-Low[i]);
         continue;  
      }
      
      //
      //
      //
      //
      //
      
      work[r][_up]    = work[r-1][_up];
      work[r][_dn]    = work[r-1][_dn];
      work[r][_brick] = work[r-1][_brick];
            double atr = iATR(NULL,0,RaiSmooth,i);

            //
            //
            //
            //
            //
            
            if (Close[i]>(work[r][_up]+work[r][_brick]))
            {
               double brickUp = 0; if (work[r][_brick]!=0) brickUp = MathFloor((Close[i]-work[r][_up])/work[r][_brick])*work[r][_brick];
                                       work[r][_up]    = work[r][_up]+brickUp;
                                       work[r][_brick] = RaiK*atr;
                                       work[r][_dn]    = work[r][_up]-work[r][_brick];
            }
            if (Close[i]<(work[r][_dn]-work[r][_brick]))
            {
               double brickDn = 0; if (work[r][_brick]!=0) brickDn = MathFloor((work[r][_dn]-Close[i])/work[r][_brick])*work[r][_brick];
                                       work[r][_dn]    = work[r][_dn]-brickDn;
                                       work[r][_brick] = RaiK*atr;
                                       work[r][_up]    = work[r][_dn]+work[r][_brick];
            }

         //
         //
         //
         //
         //
         
         raiu[i] = work[r][_up];
         raid[i] = work[r][_dn];
   }       
   return(0);
}